<script lang="ts">
  import { onMount } from 'svelte';

  let scroller: HTMLElement;

  onMount(() => {
    // when in World page, footer-nav link will be able to use scrollIntoView to navigate through slides
    const anchorsInScroller = scroller.querySelectorAll('a[href^="#"]');
    const anchorsInFooterNav = document.querySelectorAll('#footer-nav .islands a');

    function smoothScrollHandler(e: PointerEvent | Event) {
      e.preventDefault();

      const href = e.target.getAttribute('href');
      const targetElement = scroller.querySelector(href);
      targetElement?.scrollIntoView({
        behavior: 'smooth',
      });
    }

    function addEventListeners() {
      anchorsInScroller.forEach((anchor) => {
        anchor.addEventListener('click', smoothScrollHandler);
      });

      anchorsInFooterNav.forEach((anchor) => {
        anchor.addEventListener('click', smoothScrollHandler);
      });
    }

    function removeEventListeners() {
      anchorsInScroller.forEach((anchor) => {
        anchor.removeEventListener('click', smoothScrollHandler);
      });

      anchorsInFooterNav.forEach((anchor) => {
        anchor.removeEventListener('click', smoothScrollHandler);
      });
    }

    addEventListeners();

    return () => {
      removeEventListeners();
    };
  });
</script>

<div
  bind:this={scroller}
  class="scroller-container">
  <slot name="slides" />
  <div class="control">
    <slot name="control" />
  </div>
</div>

<style lang="postcss">
  .scroller-container {
    display: flex;
    width: 100%;
    height: 100vh;
    flex-direction: column;
    overflow-y: scroll;
    scroll-snap-type: y mandatory; /* Enable vertical scroll snapping */
    scrollbar-width: none;

    &::-webkit-scrollbar {
      width: 0;
    }

    & :global(.slide) {
      height: 100vh;
      scroll-snap-align: start; /* Snap at the start of each section */
    }
  }

  .control {
    position: absolute;
    top: 50%;
    background-color: rgb(184 63 83);
    transform: translateY(-50%);
  }
</style>
